Index: code/trunk/src/bullet/BulletCollision/CollisionDispatch/btSimulationIslandManager.cpp
===================================================================
--- code/trunk/src/bullet/BulletCollision/CollisionDispatch/btSimulationIslandManager.cpp	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/CollisionDispatch/btSimulationIslandManager.cpp	(revision 2882)
@@ -25,5 +25,6 @@
 #include "LinearMath/btQuickprof.h"
 
-btSimulationIslandManager::btSimulationIslandManager()
+btSimulationIslandManager::btSimulationIslandManager():
+m_splitIslands(true)
 {
 }
@@ -44,8 +45,8 @@
 	
 	{
-		btBroadphasePair* pairPtr = colWorld->getPairCache()->getOverlappingPairArrayPtr();
-
+		
 		for (int i=0;i<colWorld->getPairCache()->getNumOverlappingPairs();i++)
 		{
+			btBroadphasePair* pairPtr = colWorld->getPairCache()->getOverlappingPairArrayPtr();
 			const btBroadphasePair& collisionPair = pairPtr[i];
 			btCollisionObject* colObj0 = (btCollisionObject*)collisionPair.m_pProxy0->m_clientObject;
@@ -186,5 +187,5 @@
 			}
 
-			assert((colObj0->getIslandTag() == islandId) || (colObj0->getIslandTag() == -1));
+			btAssert((colObj0->getIslandTag() == islandId) || (colObj0->getIslandTag() == -1));
 			if (colObj0->getIslandTag() == islandId)
 			{
@@ -213,5 +214,5 @@
 				}
 
-				assert((colObj0->getIslandTag() == islandId) || (colObj0->getIslandTag() == -1));
+				btAssert((colObj0->getIslandTag() == islandId) || (colObj0->getIslandTag() == -1));
 
 				if (colObj0->getIslandTag() == islandId)
@@ -234,5 +235,5 @@
 				}
 
-				assert((colObj0->getIslandTag() == islandId) || (colObj0->getIslandTag() == -1));
+				btAssert((colObj0->getIslandTag() == islandId) || (colObj0->getIslandTag() == -1));
 
 				if (colObj0->getIslandTag() == islandId)
@@ -252,9 +253,9 @@
 	int maxNumManifolds = dispatcher->getNumManifolds();
 
-#define SPLIT_ISLANDS 1
-#ifdef SPLIT_ISLANDS
-
-	
-#endif //SPLIT_ISLANDS
+//#define SPLIT_ISLANDS 1
+//#ifdef SPLIT_ISLANDS
+
+	
+//#endif //SPLIT_ISLANDS
 
 	
@@ -280,9 +281,10 @@
 				colObj0->activate();
 			}
-#ifdef SPLIT_ISLANDS
-	//		//filtering for response
-			if (dispatcher->needsResponse(colObj0,colObj1))
-				m_islandmanifold.push_back(manifold);
-#endif //SPLIT_ISLANDS
+			if(m_splitIslands)
+			{ 
+				//filtering for response
+				if (dispatcher->needsResponse(colObj0,colObj1))
+					m_islandmanifold.push_back(manifold);
+			}
 		}
 	}
@@ -304,83 +306,85 @@
 	BT_PROFILE("processIslands");
 
-#ifndef SPLIT_ISLANDS
-	btPersistentManifold** manifold = dispatcher->getInternalManifoldPointer();
-	
-	callback->ProcessIsland(&collisionObjects[0],collisionObjects.size(),manifold,maxNumManifolds, -1);
-#else
-	// Sort manifolds, based on islands
-	// Sort the vector using predicate and std::sort
-	//std::sort(islandmanifold.begin(), islandmanifold.end(), btPersistentManifoldSortPredicate);
-
-	int numManifolds = int (m_islandmanifold.size());
-
-	//we should do radix sort, it it much faster (O(n) instead of O (n log2(n))
-	m_islandmanifold.quickSort(btPersistentManifoldSortPredicate());
-
-	//now process all active islands (sets of manifolds for now)
-
-	int startManifoldIndex = 0;
-	int endManifoldIndex = 1;
-
-	//int islandId;
-
-	
-
-//	printf("Start Islands\n");
-
-	//traverse the simulation islands, and call the solver, unless all objects are sleeping/deactivated
-	for ( startIslandIndex=0;startIslandIndex<numElem;startIslandIndex = endIslandIndex)
-	{
-		int islandId = getUnionFind().getElement(startIslandIndex).m_id;
-
-
-	       bool islandSleeping = false;
-                
-                for (endIslandIndex = startIslandIndex;(endIslandIndex<numElem) && (getUnionFind().getElement(endIslandIndex).m_id == islandId);endIslandIndex++)
-                {
-                        int i = getUnionFind().getElement(endIslandIndex).m_sz;
-                        btCollisionObject* colObj0 = collisionObjects[i];
-						m_islandBodies.push_back(colObj0);
-                        if (!colObj0->isActive())
-                                islandSleeping = true;
-                }
-                
-
-		//find the accompanying contact manifold for this islandId
-		int numIslandManifolds = 0;
-		btPersistentManifold** startManifold = 0;
-
-		if (startManifoldIndex<numManifolds)
-		{
-			int curIslandId = getIslandId(m_islandmanifold[startManifoldIndex]);
-			if (curIslandId == islandId)
-			{
-				startManifold = &m_islandmanifold[startManifoldIndex];
+	if(!m_splitIslands)
+	{
+		btPersistentManifold** manifold = dispatcher->getInternalManifoldPointer();
+		int maxNumManifolds = dispatcher->getNumManifolds();
+		callback->ProcessIsland(&collisionObjects[0],collisionObjects.size(),manifold,maxNumManifolds, -1);
+	}
+	else
+	{
+		// Sort manifolds, based on islands
+		// Sort the vector using predicate and std::sort
+		//std::sort(islandmanifold.begin(), islandmanifold.end(), btPersistentManifoldSortPredicate);
+
+		int numManifolds = int (m_islandmanifold.size());
+
+		//we should do radix sort, it it much faster (O(n) instead of O (n log2(n))
+		m_islandmanifold.quickSort(btPersistentManifoldSortPredicate());
+
+		//now process all active islands (sets of manifolds for now)
+
+		int startManifoldIndex = 0;
+		int endManifoldIndex = 1;
+
+		//int islandId;
+
+		
+
+	//	printf("Start Islands\n");
+
+		//traverse the simulation islands, and call the solver, unless all objects are sleeping/deactivated
+		for ( startIslandIndex=0;startIslandIndex<numElem;startIslandIndex = endIslandIndex)
+		{
+			int islandId = getUnionFind().getElement(startIslandIndex).m_id;
+
+
+			   bool islandSleeping = false;
+	                
+					for (endIslandIndex = startIslandIndex;(endIslandIndex<numElem) && (getUnionFind().getElement(endIslandIndex).m_id == islandId);endIslandIndex++)
+					{
+							int i = getUnionFind().getElement(endIslandIndex).m_sz;
+							btCollisionObject* colObj0 = collisionObjects[i];
+							m_islandBodies.push_back(colObj0);
+							if (!colObj0->isActive())
+									islandSleeping = true;
+					}
+	                
+
+			//find the accompanying contact manifold for this islandId
+			int numIslandManifolds = 0;
+			btPersistentManifold** startManifold = 0;
+
+			if (startManifoldIndex<numManifolds)
+			{
+				int curIslandId = getIslandId(m_islandmanifold[startManifoldIndex]);
+				if (curIslandId == islandId)
+				{
+					startManifold = &m_islandmanifold[startManifoldIndex];
+				
+					for (endManifoldIndex = startManifoldIndex+1;(endManifoldIndex<numManifolds) && (islandId == getIslandId(m_islandmanifold[endManifoldIndex]));endManifoldIndex++)
+					{
+
+					}
+					/// Process the actual simulation, only if not sleeping/deactivated
+					numIslandManifolds = endManifoldIndex-startManifoldIndex;
+				}
+
+			}
+
+			if (!islandSleeping)
+			{
+				callback->ProcessIsland(&m_islandBodies[0],m_islandBodies.size(),startManifold,numIslandManifolds, islandId);
+	//			printf("Island callback of size:%d bodies, %d manifolds\n",islandBodies.size(),numIslandManifolds);
+			}
 			
-				for (endManifoldIndex = startManifoldIndex+1;(endManifoldIndex<numManifolds) && (islandId == getIslandId(m_islandmanifold[endManifoldIndex]));endManifoldIndex++)
-				{
-
-				}
-				/// Process the actual simulation, only if not sleeping/deactivated
-				numIslandManifolds = endManifoldIndex-startManifoldIndex;
-			}
-
-		}
-
-		if (!islandSleeping)
-		{
-			callback->ProcessIsland(&m_islandBodies[0],m_islandBodies.size(),startManifold,numIslandManifolds, islandId);
-//			printf("Island callback of size:%d bodies, %d manifolds\n",islandBodies.size(),numIslandManifolds);
-		}
-		
-		if (numIslandManifolds)
-		{
-			startManifoldIndex = endManifoldIndex;
-		}
-
-		m_islandBodies.resize(0);
-	}
-#endif //SPLIT_ISLANDS
-
-
-}
+			if (numIslandManifolds)
+			{
+				startManifoldIndex = endManifoldIndex;
+			}
+
+			m_islandBodies.resize(0);
+		}
+	} // else if(!splitIslands) 
+
+}
Index: code/trunk/src/bullet/BulletCollision/CollisionDispatch/btSimulationIslandManager.h
===================================================================
--- code/trunk/src/bullet/BulletCollision/CollisionDispatch/btSimulationIslandManager.h	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/CollisionDispatch/btSimulationIslandManager.h	(revision 2882)
@@ -36,4 +36,5 @@
 	btAlignedObjectArray<btCollisionObject* >  m_islandBodies;
 	
+	bool m_splitIslands;
 	
 public:
@@ -66,4 +67,13 @@
 	void buildIslands(btDispatcher* dispatcher,btCollisionWorld* colWorld);
 
+	bool getSplitIslands()
+	{
+		return m_splitIslands;
+	}
+	void setSplitIslands(bool doSplitIslands)
+	{
+		m_splitIslands = doSplitIslands;
+	}
+
 };
 
Index: code/trunk/src/bullet/BulletCollision/CollisionDispatch/btSphereSphereCollisionAlgorithm.cpp
===================================================================
--- code/trunk/src/bullet/BulletCollision/CollisionDispatch/btSphereSphereCollisionAlgorithm.cpp	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/CollisionDispatch/btSphereSphereCollisionAlgorithm.cpp	(revision 2882)
@@ -79,5 +79,5 @@
 
 	///point on A (worldspace)
-	btVector3 pos0 = col0->getWorldTransform().getOrigin() - radius0 * normalOnSurfaceB;
+	///btVector3 pos0 = col0->getWorldTransform().getOrigin() - radius0 * normalOnSurfaceB;
 	///point on B (worldspace)
 	btVector3 pos1 = col1->getWorldTransform().getOrigin() + radius1* normalOnSurfaceB;
Index: code/trunk/src/bullet/BulletCollision/CollisionDispatch/btUnionFind.cpp
===================================================================
--- code/trunk/src/bullet/BulletCollision/CollisionDispatch/btUnionFind.cpp	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/CollisionDispatch/btUnionFind.cpp	(revision 2882)
@@ -15,6 +15,4 @@
 
 #include "btUnionFind.h"
-#include <assert.h>
-
 
 
Index: code/trunk/src/bullet/BulletCollision/CollisionDispatch/btUnionFind.h
===================================================================
--- code/trunk/src/bullet/BulletCollision/CollisionDispatch/btUnionFind.h	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/CollisionDispatch/btUnionFind.h	(revision 2882)
@@ -99,6 +99,6 @@
 		int find(int x)
 		{ 
-			//assert(x < m_N);
-			//assert(x >= 0);
+			//btAssert(x < m_N);
+			//btAssert(x >= 0);
 
 			while (x != m_elements[x].m_id) 
@@ -111,6 +111,6 @@
 		#endif //
 				x = m_elements[x].m_id;
-				//assert(x < m_N);
-				//assert(x >= 0);
+				//btAssert(x < m_N);
+				//btAssert(x >= 0);
 
 			}
Index: code/trunk/src/bullet/BulletCollision/CollisionShapes/btBoxShape.h
===================================================================
--- code/trunk/src/bullet/BulletCollision/CollisionShapes/btBoxShape.h	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/CollisionShapes/btBoxShape.h	(revision 2882)
@@ -162,29 +162,23 @@
 		{
 		case 0:
-			plane.setValue(btScalar(1.),btScalar(0.),btScalar(0.));
-			plane[3] = -halfExtents.x();
+			plane.setValue(btScalar(1.),btScalar(0.),btScalar(0.),-halfExtents.x());
 			break;
 		case 1:
-			plane.setValue(btScalar(-1.),btScalar(0.),btScalar(0.));
-			plane[3] = -halfExtents.x();
+			plane.setValue(btScalar(-1.),btScalar(0.),btScalar(0.),-halfExtents.x());
 			break;
 		case 2:
-			plane.setValue(btScalar(0.),btScalar(1.),btScalar(0.));
-			plane[3] = -halfExtents.y();
+			plane.setValue(btScalar(0.),btScalar(1.),btScalar(0.),-halfExtents.y());
 			break;
 		case 3:
-			plane.setValue(btScalar(0.),btScalar(-1.),btScalar(0.));
-			plane[3] = -halfExtents.y();
+			plane.setValue(btScalar(0.),btScalar(-1.),btScalar(0.),-halfExtents.y());
 			break;
 		case 4:
-			plane.setValue(btScalar(0.),btScalar(0.),btScalar(1.));
-			plane[3] = -halfExtents.z();
+			plane.setValue(btScalar(0.),btScalar(0.),btScalar(1.),-halfExtents.z());
 			break;
 		case 5:
-			plane.setValue(btScalar(0.),btScalar(0.),btScalar(-1.));
-			plane[3] = -halfExtents.z();
+			plane.setValue(btScalar(0.),btScalar(0.),btScalar(-1.),-halfExtents.z());
 			break;
 		default:
-			assert(0);
+			btAssert(0);
 		}
 	}
@@ -313,5 +307,5 @@
 			break;
 		default:
-			assert(0);
+			btAssert(0);
 		}
 	}
Index: code/trunk/src/bullet/BulletCollision/CollisionShapes/btCollisionShape.cpp
===================================================================
--- code/trunk/src/bullet/BulletCollision/CollisionShapes/btCollisionShape.cpp	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/CollisionShapes/btCollisionShape.cpp	(revision 2882)
@@ -15,4 +15,7 @@
 
 #include "BulletCollision/CollisionShapes/btCollisionShape.h"
+
+
+btScalar gContactThresholdFactor=btScalar(0.02);
 
 
@@ -45,6 +48,5 @@
 btScalar	btCollisionShape::getContactBreakingThreshold() const
 {
-	///@todo make this 0.1 configurable
-	return getAngularMotionDisc() * btScalar(0.1);
+	return getAngularMotionDisc() * gContactThresholdFactor;
 }
 btScalar	btCollisionShape::getAngularMotionDisc() const
Index: code/trunk/src/bullet/BulletCollision/CollisionShapes/btCompoundShape.cpp
===================================================================
--- code/trunk/src/bullet/BulletCollision/CollisionShapes/btCompoundShape.cpp	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/CollisionShapes/btCompoundShape.cpp	(revision 2882)
@@ -23,5 +23,6 @@
 m_collisionMargin(btScalar(0.)),
 m_localScaling(btScalar(1.),btScalar(1.),btScalar(1.)),
-m_dynamicAabbTree(0)
+m_dynamicAabbTree(0),
+m_updateRevision(1)
 {
 	m_shapeType = COMPOUND_SHAPE_PROXYTYPE;
@@ -47,4 +48,5 @@
 void	btCompoundShape::addChildShape(const btTransform& localTransform,btCollisionShape* shape)
 {
+	m_updateRevision++;
 	//m_childTransforms.push_back(localTransform);
 	//m_childShapes.push_back(shape);
@@ -55,6 +57,5 @@
 	child.m_childMargin = shape->getMargin();
 
-	m_children.push_back(child);
-
+	
 	//extend the local aabbMin/aabbMax
 	btVector3 localAabbMin,localAabbMax;
@@ -75,7 +76,9 @@
 	{
 		const btDbvtVolume	bounds=btDbvtVolume::FromMM(localAabbMin,localAabbMax);
-		int index = m_children.size()-1;
+		int index = m_children.size();
 		child.m_node = m_dynamicAabbTree->insert(bounds,(void*)index);
 	}
+
+	m_children.push_back(child);
 
 }
@@ -100,4 +103,5 @@
 void btCompoundShape::removeChildShapeByIndex(int childShapeIndex)
 {
+	m_updateRevision++;
 	btAssert(childShapeIndex >=0 && childShapeIndex < m_children.size());
 	if (m_dynamicAabbTree)
@@ -114,4 +118,5 @@
 void btCompoundShape::removeChildShape(btCollisionShape* shape)
 {
+	m_updateRevision++;
 	// Find the children containing the shape specified, and remove those children.
 	//note: there might be multiple children using the same shape!
@@ -140,4 +145,5 @@
 	// Recalculate the local aabb
 	// Brute force, it iterates over all the shapes left.
+
 	m_localAabbMin = btVector3(btScalar(1e30),btScalar(1e30),btScalar(1e30));
 	m_localAabbMax = btVector3(btScalar(-1e30),btScalar(-1e30),btScalar(-1e30));
@@ -162,6 +168,14 @@
 {
 	btVector3 localHalfExtents = btScalar(0.5)*(m_localAabbMax-m_localAabbMin);
+	btVector3 localCenter = btScalar(0.5)*(m_localAabbMax+m_localAabbMin);
+	
+	//avoid an illegal AABB when there are no children
+	if (!m_children.size())
+	{
+		localHalfExtents.setValue(0,0,0);
+		localCenter.setValue(0,0,0);
+	}
 	localHalfExtents += btVector3(getMargin(),getMargin(),getMargin());
-	btVector3 localCenter = btScalar(0.5)*(m_localAabbMax+m_localAabbMin);
+		
 
 	btMatrix3x3 abs_b = trans.getBasis().absolute();  
@@ -174,5 +188,5 @@
 	aabbMin = center-extent;
 	aabbMax = center+extent;
-
+	
 }
 
Index: code/trunk/src/bullet/BulletCollision/CollisionShapes/btCompoundShape.h
===================================================================
--- code/trunk/src/bullet/BulletCollision/CollisionShapes/btCompoundShape.h	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/CollisionShapes/btCompoundShape.h	(revision 2882)
@@ -59,4 +59,7 @@
 
 	btDbvt*							m_dynamicAabbTree;
+
+	///increment m_updateRevision when adding/removing/replacing child shapes, so that some caches can be updated
+	int								m_updateRevision;
 
 public:
@@ -153,4 +156,8 @@
 	void calculatePrincipalAxisTransform(btScalar* masses, btTransform& principal, btVector3& inertia) const;
 
+	int	getUpdateRevision() const
+	{
+		return m_updateRevision;
+	}
 
 private:
Index: code/trunk/src/bullet/BulletCollision/CollisionShapes/btConeShape.cpp
===================================================================
--- code/trunk/src/bullet/BulletCollision/CollisionShapes/btConeShape.cpp	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/CollisionShapes/btConeShape.cpp	(revision 2882)
@@ -61,5 +61,5 @@
 		break;
 	default:
-		assert(0);
+		btAssert(0);
 	};
 }
Index: code/trunk/src/bullet/BulletCollision/CollisionShapes/btConvexHullShape.cpp
===================================================================
--- code/trunk/src/bullet/BulletCollision/CollisionShapes/btConvexHullShape.cpp	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/CollisionShapes/btConvexHullShape.cpp	(revision 2882)
@@ -182,5 +182,5 @@
 bool btConvexHullShape::isInside(const btVector3& ,btScalar ) const
 {
-	assert(0);
+	btAssert(0);
 	return false;
 }
Index: code/trunk/src/bullet/BulletCollision/CollisionShapes/btConvexPointCloudShape.cpp
===================================================================
--- code/trunk/src/bullet/BulletCollision/CollisionShapes/btConvexPointCloudShape.cpp	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/CollisionShapes/btConvexPointCloudShape.cpp	(revision 2882)
@@ -151,5 +151,5 @@
 bool btConvexPointCloudShape::isInside(const btVector3& ,btScalar ) const
 {
-	assert(0);
+	btAssert(0);
 	return false;
 }
Index: code/trunk/src/bullet/BulletCollision/CollisionShapes/btConvexShape.cpp
===================================================================
--- code/trunk/src/bullet/BulletCollision/CollisionShapes/btConvexShape.cpp	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/CollisionShapes/btConvexShape.cpp	(revision 2882)
@@ -155,5 +155,4 @@
 
 		btCapsuleShape* capsuleShape = (btCapsuleShape*)this;
-		btVector3 halfExtents = capsuleShape->getImplicitShapeDimensions();
 		btScalar halfHeight = capsuleShape->getHalfHeight();
 		int capsuleUpAxis = capsuleShape->getUpAxis();
@@ -302,6 +301,6 @@
 	{
 		btSphereShape* sphereShape = (btSphereShape*)this;
-		float radius = sphereShape->getImplicitShapeDimensions().getX();// * convexShape->getLocalScaling().getX();
-		float margin = radius + sphereShape->getMarginNonVirtual();
+		btScalar radius = sphereShape->getImplicitShapeDimensions().getX();// * convexShape->getLocalScaling().getX();
+		btScalar margin = radius + sphereShape->getMarginNonVirtual();
 		const btVector3& center = t.getOrigin();
 		btVector3 extent(margin,margin,margin);
@@ -315,5 +314,5 @@
 	{
 		btBoxShape* convexShape = (btBoxShape*)this;
-		float margin=convexShape->getMarginNonVirtual();
+		btScalar margin=convexShape->getMarginNonVirtual();
 		btVector3 halfExtents = convexShape->getImplicitShapeDimensions();
 		halfExtents += btVector3(margin,margin,margin);
Index: code/trunk/src/bullet/BulletCollision/CollisionShapes/btHeightfieldTerrainShape.cpp
===================================================================
--- code/trunk/src/bullet/BulletCollision/CollisionShapes/btHeightfieldTerrainShape.cpp	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/CollisionShapes/btHeightfieldTerrainShape.cpp	(revision 2882)
@@ -145,5 +145,10 @@
 }
 
-btScalar	btHeightfieldTerrainShape::getHeightFieldValue(int x,int y) const
+
+/// This returns the "raw" (user's initial) height, not the actual height.
+/// The actual height needs to be adjusted to be relative to the center
+///   of the heightfield's AABB.
+btScalar
+btHeightfieldTerrainShape::getRawHeightFieldValue(int x,int y) const
 {
 	btScalar val = 0.f;
@@ -182,8 +187,7 @@
 
 
-
+/// this returns the vertex in bullet-local coordinates
 void	btHeightfieldTerrainShape::getVertex(int x,int y,btVector3& vertex) const
 {
-
 	btAssert(x>=0);
 	btAssert(y>=0);
@@ -191,6 +195,5 @@
 	btAssert(y<m_heightStickLength);
 
-
-	btScalar	height = getHeightFieldValue(x,y);
+	btScalar	height = getRawHeightFieldValue(x,y);
 
 	switch (m_upAxis)
@@ -199,5 +202,5 @@
 		{
 		vertex.setValue(
-			height,
+			height - m_localOrigin.getX(),
 			(-m_width/btScalar(2.0)) + x,
 			(-m_length/btScalar(2.0) ) + y
@@ -209,5 +212,5 @@
 			vertex.setValue(
 			(-m_width/btScalar(2.0)) + x,
-			height,
+			height - m_localOrigin.getY(),
 			(-m_length/btScalar(2.0)) + y
 			);
@@ -219,5 +222,5 @@
 			(-m_width/btScalar(2.0)) + x,
 			(-m_length/btScalar(2.0)) + y,
-			height
+			height - m_localOrigin.getZ()
 			);
 			break;
@@ -231,5 +234,4 @@
 
 	vertex*=m_localScaling;
-	
 }
 
@@ -239,5 +241,5 @@
 getQuantized
 (
-float x
+btScalar x
 )
 {
Index: code/trunk/src/bullet/BulletCollision/CollisionShapes/btHeightfieldTerrainShape.h
===================================================================
--- code/trunk/src/bullet/BulletCollision/CollisionShapes/btHeightfieldTerrainShape.h	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/CollisionShapes/btHeightfieldTerrainShape.h	(revision 2882)
@@ -30,4 +30,15 @@
   center (as determined by width and length and height, with each
   axis multiplied by the localScaling).
+
+  \b NOTE: be careful with coordinates.  If you have a heightfield with a local
+  min height of -100m, and a max height of +500m, you may be tempted to place it
+  at the origin (0,0) and expect the heights in world coordinates to be
+  -100 to +500 meters.
+  Actually, the heights will be -300 to +300m, because bullet will re-center
+  the heightfield based on its AABB (which is determined by the min/max
+  heights).  So keep in mind that once you create a btHeightfieldTerrainShape
+  object, the heights will be adjusted relative to the center of the AABB.  This
+  is different to the behavior of many rendering engines, but is useful for
+  physics engines.
 
   Most (but not all) rendering and heightfield libraries assume upAxis = 1
@@ -89,5 +100,5 @@
 	btVector3	m_localScaling;
 
-	virtual btScalar	getHeightFieldValue(int x,int y) const;
+	virtual btScalar	getRawHeightFieldValue(int x,int y) const;
 	void		quantizeWithClamp(int* out, const btVector3& point,int isMax) const;
 	void		getVertex(int x,int y,btVector3& vertex) const;
Index: code/trunk/src/bullet/BulletCollision/CollisionShapes/btMinkowskiSumShape.cpp
===================================================================
--- code/trunk/src/bullet/BulletCollision/CollisionShapes/btMinkowskiSumShape.cpp	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/CollisionShapes/btMinkowskiSumShape.cpp	(revision 2882)
@@ -29,6 +29,6 @@
 btVector3 btMinkowskiSumShape::localGetSupportingVertexWithoutMargin(const btVector3& vec)const
 {
-	btVector3 supVertexA = m_transA(m_shapeA->localGetSupportingVertexWithoutMargin(-vec*m_transA.getBasis()));
-	btVector3 supVertexB = m_transB(m_shapeB->localGetSupportingVertexWithoutMargin(vec*m_transB.getBasis()));
+	btVector3 supVertexA = m_transA(m_shapeA->localGetSupportingVertexWithoutMargin(vec*m_transA.getBasis()));
+	btVector3 supVertexB = m_transB(m_shapeB->localGetSupportingVertexWithoutMargin(-vec*m_transB.getBasis()));
 	return  supVertexA - supVertexB;
 }
Index: code/trunk/src/bullet/BulletCollision/CollisionShapes/btMultimaterialTriangleMeshShape.h
===================================================================
--- code/trunk/src/bullet/BulletCollision/CollisionShapes/btMultimaterialTriangleMeshShape.h	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/CollisionShapes/btMultimaterialTriangleMeshShape.h	(revision 2882)
@@ -32,8 +32,10 @@
 	BT_DECLARE_ALIGNED_ALLOCATOR();
 
-    btMultimaterialTriangleMeshShape(): btBvhTriangleMeshShape() {}
+    btMultimaterialTriangleMeshShape(): btBvhTriangleMeshShape() {m_shapeType = MULTIMATERIAL_TRIANGLE_MESH_PROXYTYPE;}
     btMultimaterialTriangleMeshShape(btStridingMeshInterface* meshInterface, bool useQuantizedAabbCompression, bool buildBvh = true):
         btBvhTriangleMeshShape(meshInterface, useQuantizedAabbCompression, buildBvh)
         {
+            m_shapeType = MULTIMATERIAL_TRIANGLE_MESH_PROXYTYPE;
+
             btVector3 m_triangle[3];
             const unsigned char *vertexbase;
@@ -68,4 +70,6 @@
         btBvhTriangleMeshShape(meshInterface, useQuantizedAabbCompression, bvhAabbMin, bvhAabbMax, buildBvh)
         {
+            m_shapeType = MULTIMATERIAL_TRIANGLE_MESH_PROXYTYPE;
+
             btVector3 m_triangle[3];
             const unsigned char *vertexbase;
@@ -108,9 +112,4 @@
 */
     }
-	virtual int	getShapeType() const
-	{
-		return MULTIMATERIAL_TRIANGLE_MESH_PROXYTYPE;
-	}
-	
 	//debugging
 	virtual const char*	getName()const {return "MULTIMATERIALTRIANGLEMESH";}
Index: code/trunk/src/bullet/BulletCollision/CollisionShapes/btSphereShape.h
===================================================================
--- code/trunk/src/bullet/BulletCollision/CollisionShapes/btSphereShape.h	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/CollisionShapes/btSphereShape.h	(revision 2882)
@@ -48,4 +48,10 @@
 	btScalar	getRadius() const { return m_implicitShapeDimensions.getX() * m_localScaling.getX();}
 
+	void	setUnscaledRadius(btScalar	radius)
+	{
+		m_implicitShapeDimensions.setX(radius);
+		btConvexInternalShape::setMargin(radius);
+	}
+
 	//debugging
 	virtual const char*	getName()const {return "SPHERE";}
Index: code/trunk/src/bullet/BulletCollision/CollisionShapes/btTriangleIndexVertexArray.cpp
===================================================================
--- code/trunk/src/bullet/BulletCollision/CollisionShapes/btTriangleIndexVertexArray.cpp	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/CollisionShapes/btTriangleIndexVertexArray.cpp	(revision 2882)
@@ -83,5 +83,6 @@
 }
 
-void	btTriangleIndexVertexArray::setPremadeAabb(const btVector3& aabbMin, const btVector3& aabbMax )
+
+void	btTriangleIndexVertexArray::setPremadeAabb(const btVector3& aabbMin, const btVector3& aabbMax ) const
 {
 	m_aabbMin = aabbMin;
@@ -96,2 +97,3 @@
 }
 
+
Index: code/trunk/src/bullet/BulletCollision/CollisionShapes/btTriangleIndexVertexArray.h
===================================================================
--- code/trunk/src/bullet/BulletCollision/CollisionShapes/btTriangleIndexVertexArray.h	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/CollisionShapes/btTriangleIndexVertexArray.h	(revision 2882)
@@ -53,7 +53,7 @@
 	IndexedMeshArray	m_indexedMeshes;
 	int m_pad[2];
-	int m_hasAabb; // using int instead of bool to maintain alignment
-	btVector3 m_aabbMin;
-	btVector3 m_aabbMax;
+	mutable int m_hasAabb; // using int instead of bool to maintain alignment
+	mutable btVector3 m_aabbMin;
+	mutable btVector3 m_aabbMax;
 
 public:
@@ -107,5 +107,5 @@
 
 	virtual bool	hasPremadeAabb() const;
-	virtual void	setPremadeAabb(const btVector3& aabbMin, const btVector3& aabbMax );
+	virtual void	setPremadeAabb(const btVector3& aabbMin, const btVector3& aabbMax ) const;
 	virtual void	getPremadeAabb(btVector3* aabbMin, btVector3* aabbMax ) const;
 
Index: code/trunk/src/bullet/BulletCollision/CollisionShapes/btTriangleMesh.cpp
===================================================================
--- code/trunk/src/bullet/BulletCollision/CollisionShapes/btTriangleMesh.cpp	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/CollisionShapes/btTriangleMesh.cpp	(revision 2882)
@@ -36,5 +36,5 @@
 	{
 		m_indexedMeshes[0].m_numTriangles = m_32bitIndices.size()/3;
-		m_indexedMeshes[0].m_triangleIndexBase = (unsigned char*) &m_32bitIndices[0];
+		m_indexedMeshes[0].m_triangleIndexBase = 0;
 		m_indexedMeshes[0].m_indexType = PHY_INTEGER;
 		m_indexedMeshes[0].m_triangleIndexStride = 3*sizeof(int);
@@ -42,5 +42,5 @@
 	{
 		m_indexedMeshes[0].m_numTriangles = m_16bitIndices.size()/3;
-		m_indexedMeshes[0].m_triangleIndexBase = (unsigned char*) &m_16bitIndices[0];
+		m_indexedMeshes[0].m_triangleIndexBase = 0;
 		m_indexedMeshes[0].m_indexType = PHY_SHORT;
 		m_indexedMeshes[0].m_triangleIndexStride = 3*sizeof(short int);
@@ -50,10 +50,10 @@
 	{
 		m_indexedMeshes[0].m_numVertices = m_4componentVertices.size();
-		m_indexedMeshes[0].m_vertexBase = (unsigned char*)&m_4componentVertices[0];
+		m_indexedMeshes[0].m_vertexBase = 0;
 		m_indexedMeshes[0].m_vertexStride = sizeof(btVector3);
 	} else
 	{
 		m_indexedMeshes[0].m_numVertices = m_3componentVertices.size()/3;
-		m_indexedMeshes[0].m_vertexBase = (unsigned char*)&m_3componentVertices[0];
+		m_indexedMeshes[0].m_vertexBase = 0;
 		m_indexedMeshes[0].m_vertexStride = 3*sizeof(btScalar);
 	}
@@ -112,7 +112,7 @@
 			}
 	}
-		m_3componentVertices.push_back(vertex.getX());
-		m_3componentVertices.push_back(vertex.getY());
-		m_3componentVertices.push_back(vertex.getZ());
+		m_3componentVertices.push_back((float)vertex.getX());
+		m_3componentVertices.push_back((float)vertex.getY());
+		m_3componentVertices.push_back((float)vertex.getZ());
 		m_indexedMeshes[0].m_numVertices++;
 		m_indexedMeshes[0].m_vertexBase = (unsigned char*)&m_3componentVertices[0];
Index: code/trunk/src/bullet/BulletCollision/CollisionShapes/btTriangleMeshShape.h
===================================================================
--- code/trunk/src/bullet/BulletCollision/CollisionShapes/btTriangleMeshShape.h	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/CollisionShapes/btTriangleMeshShape.h	(revision 2882)
@@ -41,5 +41,5 @@
 	virtual btVector3	localGetSupportingVertexWithoutMargin(const btVector3& vec)const
 	{
-		assert(0);
+		btAssert(0);
 		return localGetSupportingVertex(vec);
 	}
Index: code/trunk/src/bullet/BulletCollision/Gimpact/btGImpactBvh.cpp
===================================================================
--- code/trunk/src/bullet/BulletCollision/Gimpact/btGImpactBvh.cpp	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/Gimpact/btGImpactBvh.cpp	(revision 2882)
@@ -151,6 +151,5 @@
 	}
 
-	bool unbal = (splitIndex==startIndex) || (splitIndex == (endIndex));
-	btAssert(!unbal);
+	btAssert(!((splitIndex==startIndex) || (splitIndex == (endIndex))));
 
 	return splitIndex;
Index: code/trunk/src/bullet/BulletCollision/Gimpact/btGImpactQuantizedBvh.cpp
===================================================================
--- code/trunk/src/bullet/BulletCollision/Gimpact/btGImpactQuantizedBvh.cpp	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/Gimpact/btGImpactQuantizedBvh.cpp	(revision 2882)
@@ -172,6 +172,5 @@
 	}
 
-	bool unbal = (splitIndex==startIndex) || (splitIndex == (endIndex));
-	btAssert(!unbal);
+	btAssert(!((splitIndex==startIndex) || (splitIndex == (endIndex))));
 
 	return splitIndex;
Index: code/trunk/src/bullet/BulletCollision/Gimpact/btGImpactShape.h
===================================================================
--- code/trunk/src/bullet/BulletCollision/Gimpact/btGImpactShape.h	(revision 2881)
+++ code/trunk/src/bullet/BulletCollision/Gimpact/btGImpactShape.h	(revision 2882)
@@ -882,4 +882,6 @@
 class btGImpactMeshShape : public btGImpactShapeInterface
 {
+	btStridingMeshInterface* m_meshInterface;
+
 protected:
 	btAlignedObjectArray<btGImpactMeshShapePart*> m_mesh_parts;
@@ -908,4 +910,5 @@
 	btGImpactMeshShape(btStridingMeshInterface * meshInterface)
 	{
+		m_meshInterface = meshInterface;
 		buildMeshParts(meshInterface);
 	}
@@ -923,4 +926,13 @@
 
 
+	btStridingMeshInterface* getMeshInterface()
+	{
+		return m_meshInterface;
+	}
+
+	const btStridingMeshInterface* getMeshInterface() const
+	{
+		return m_meshInterface;
+	}
 
 	int getMeshPartCount() const
@@ -1034,10 +1046,10 @@
 
 	//! call when reading child shapes
-	virtual void lockChildShapes()
-	{
-		btAssert(0);
-	}
-
-	virtual void unlockChildShapes()
+	virtual void lockChildShapes() const
+	{
+		btAssert(0);
+	}
+
+	virtual void unlockChildShapes() const
 	{
 		btAssert(0);
